/*************************************************************************
*
* YPOPs!
*
* YPOPs! is an application that provides POP3 access to Yahoo! Mail.
* You do not need to enable POP3 access with Yahoo! to use this program.
* This program works within the license agreement of Yahoo! to provide
* you with POP3 access.
*
* YPOPs! emulates a POP3 mail server and should work with most of the
* email clients. Since YPOPs! is not a full-fledged POP3 mail server
* you might find it not working with all mail clients. Do keep us informed
* about such mail clients so that we can enhance YPOPs!
*
* Official Website: http://yahoopops.sourceforge.net
*
*-------------------------------------------------------------------------
*
* Name    :	ConfigMiscPage.cpp
*
* Purpose : Configuration Dialog - Misc Page
*
* Authors : Anuj Seth
* 			K.Shyam
*
* License : GNU Public License (Version 2 or later)
*
*-------------------------------------------------------------------------
*
* THIS SOFTWARE IS PROVIDED ``AS IS'' BY THE AUTHORS AND INDEPENDENT
* CONTRIBUTORS AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR 
* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
* EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
* PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*************************************************************************/
#include "stdafx.h"

#ifdef WIN32
#include "YPOPs.h"
#include "ConfigMiscPage.h"
#include <commctrl.h>
#include <shlobj.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CDataHolder settings;

IMPLEMENT_DYNCREATE(CConfigMiscPage, CPropertyPage)

CConfigMiscPage::CConfigMiscPage() : CCustomPropertyPage(CConfigMiscPage::IDD)
{
	//{{AFX_DATA_INIT(CConfigMiscPage)
	m_bQuietMode = FALSE;
	m_bAutoStartWithWindows = FALSE;
	m_bAlwaysOnTop = FALSE;
	m_bHideTrayIcon = FALSE;
	m_bEnableUIDL = FALSE;
	m_UserAgent = _T(DEF_USERAGENT);
	m_YahooDomain = _T(DEF_YAHOODOMAIN);
	//}}AFX_DATA_INIT
}

CConfigMiscPage::~CConfigMiscPage()
{
}

void CConfigMiscPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigMiscPage)
	DDX_Check(pDX, IDC_QUIET_MODE, m_bQuietMode);
	DDX_Check(pDX, IDC_AUTO_START, m_bAutoStartWithWindows);
	DDX_Check(pDX, IDC_ALWAYS_ON_TOP, m_bAlwaysOnTop);
	DDX_Check(pDX, IDC_HIDE_ICON, m_bHideTrayIcon);
	DDX_Check(pDX, IDC_ENABLE_UIDL, m_bEnableUIDL);
	DDX_CBStringExact(pDX, IDC_USER_AGENT, m_UserAgent);
	DDX_CBStringExact(pDX, IDC_YAHOO_DOMAIN, m_YahooDomain);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CConfigMiscPage, CCustomPropertyPage)
	//{{AFX_MSG_MAP(CConfigMiscPage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CConfigMiscPage::Init(CDataHolder &data)
{
    
	m_UserAgent = data.m_UserAgent;
	m_bQuietMode = data.m_bQuietMode;
	m_bAutoStartWithWindows = data.m_bAutoStartWithWindows;
    m_bAlwaysOnTop = data.m_bAlwaysOnTop;
    m_bEnableUIDL = data.m_bEnableUIDL;
    m_bHideTrayIcon = data.m_bHideTrayIcon;
    m_YahooDomain = data.m_sYahooDomain;

	UpdateData(FALSE);
}

BOOL CConfigMiscPage::ValidateData(void)
{
	UpdateData(TRUE);

	m_UserAgent.TrimLeft();
	if (m_UserAgent.IsEmpty())
	{
		::AfxMessageBox("You must enter a User Agent string", MB_OK | MB_ICONSTOP);
		return FALSE;
	}

	m_YahooDomain.TrimLeft();
	if (m_YahooDomain.IsEmpty())
	{
		::AfxMessageBox("You must enter a Yahoo Domain", MB_OK | MB_ICONSTOP);
		return FALSE;
	}

	return TRUE;
}

void CConfigMiscPage::SaveData(CDataHolder &data)
{
	settings.m_UserAgent = CStringEx(m_UserAgent);
	settings.m_bQuietMode = m_bQuietMode;
	settings.m_bAutoStartWithWindows = m_bAutoStartWithWindows;
    settings.m_bAlwaysOnTop = m_bAlwaysOnTop;
    settings.m_bEnableUIDL = m_bEnableUIDL;
	settings.m_bHideTrayIcon = m_bHideTrayIcon;
    settings.m_sYahooDomain = CStringEx(m_YahooDomain);

	data.m_UserAgent = settings.m_UserAgent;
	data.m_bQuietMode = m_bQuietMode;
	data.m_bAutoStartWithWindows = m_bAutoStartWithWindows;
    data.m_bAlwaysOnTop = m_bAlwaysOnTop;
    data.m_bEnableUIDL = m_bEnableUIDL;
	data.m_bHideTrayIcon = m_bHideTrayIcon;
    data.m_sYahooDomain = settings.m_sYahooDomain;
}

#endif // #ifdef WIN32
