/*************************************************************************
*
* YPOPs!
*
* YPOPs! is an application that provides POP3 access to Yahoo! Mail.
* You do not need to enable POP3 access with Yahoo! to use this program.
* This program works within the license agreement of Yahoo! to provide
* you with POP3 access.
*
* YPOPs! emulates a POP3 mail server and should work with most of the
* email clients. Since YPOPs! is not a full-fledged POP3 mail server
* you might find it not working with all mail clients. Do keep us informed
* about such mail clients so that we can enhance YPOPs!
*
* Official Website: http://yahoopops.sourceforge.net
*
*-------------------------------------------------------------------------
*
* Name    :	YahooStuff.h
*
* Purpose : Yahoo URL definitions and string tables
*
* Authors : Anuj Seth
* 			K.Shyam
*
* License : GNU Public License (Version 2 or later)
*
*-------------------------------------------------------------------------
*
* THIS SOFTWARE IS PROVIDED ``AS IS'' BY THE AUTHORS AND INDEPENDENT
* CONTRIBUTORS AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR 
* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
* EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
* PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*************************************************************************/
#ifndef _YAHOO_STUFF_H_
#define _YAHOO_STUFF_H_

/* Preconfigured Yahoo URLs */
#define HTTP_LOGIN		0
#define HTTPS_LOGIN		1
#define MBOX			2
#define MSG				3
#define DEL				4
#define TRASH			5
#define UNREAD			6
#define COMPOSE_GET		7
#define COMPOSE_POST	8
#define COMPOSE_ATTACH	9
#define EMPTY_BULKMAIL  10
#define LOGOFF			11
#define NUM_URLS		12

/* Yahoo standard mailbox (folder) names */
extern char yahoo[NUM_URLS][100];
extern char yahooMbox[3][20];

void YahooSetup(void);

enum MAILBOX {MB_INBOX, MB_BULKMAIL, MB_TRASH};

#define YAHOO_ERROR_SESSION_EXPIRED "Your login session has expired."

#endif

