#define VERS GetFileVersion('src\Release\ypops.exe')
#if Copy(VERS, Len(VERS)-1,2) == '.0'
#define VER Copy(VERS, 1, 5)
#else
#define VER VERS
#endif

[Files]
Source: src\Release\ypops.exe; DestDir: {app}; Flags: replacesameversion
Source: src\WinHelp\ypops.chm; DestDir: {app}
Source: lib\curl-7.15.1\lib\libcurl.dll; DestDir: {app}
Source: lib\openssl-0.9.8a\out32dll\libeay32.dll; DestDir: {app}
Source: lib\openssl-0.9.8a\out32dll\ssleay32.dll; DestDir: {app}
Source: lib\mimepp-1.3.3\rel\mimepp_core.dll; DestDir: {app}
Source: lib\mimepp-1.3.3\rel\mimepp_net.dll; DestDir: {app}
Source: lib\mimepp-1.3.3\rel\mimepp_util.dll; DestDir: {app}
Source: docs\credits.txt; DestDir: {app}
Source: docs\license.txt; DestDir: {app}
Source: docs\history.html; DestDir: {app}
Source: Website.url; DestDir: {app}

[Setup]
VersionInfoVersion={#VER}
VersionInfoDescription=YPOPs! {#VER}
AppName=YPOPs
AppVerName=YPOPs! {#VER}
LicenseFile=docs\install_license.txt
UsePreviousAppDir=false
ShowLanguageDialog=yes
DefaultGroupName=YPOPs!
DefaultDirName={pf}\YPOPs
AppSupportURL=http://yahoopops.sourceforge.net
AppUpdatesURL=http://yahoopops.sourceforge.net
OutputBaseFilename=ypops-win-{#VER}

[Icons]
Name: {group}\YPOPs!; Filename: {app}\ypops.exe; WorkingDir: {app}; IconFilename: {app}\ypops.exe; IconIndex: 0
Name: {group}\YPOPs! Help; Filename: {app}\ypops.chm
Name: {group}\YPOPs! Website; Filename: {app}\Website.url
Name: {group}\Documents\Credits; Filename: {app}\credits.txt
Name: {group}\Documents\General Public License (GPL); Filename: {app}\license.txt
Name: {group}\Documents\History; Filename: {app}\history.html
Name: {group}\Uninstall YPOPs!; Filename: {uninstallexe}; WorkingDir: {pf}
Name: {userdesktop}\YPOPs!; Filename: {app}\ypops.exe; WorkingDir: {app}; IconFilename: {app}\ypops.exe; IconIndex: 0; Tasks: desktop_icon

[Tasks]
Name: desktop_icon; Description: Create Desktop Icon

[Run]
Filename: {app}\ypops.exe; WorkingDir: {app}; Flags: postinstall nowait

[Registry]
Root: HKCU; Subkey: Software\YahooPOPs!; Flags: uninsdeletekey dontcreatekey deletekey
Root: HKCU; Subkey: Software\Microsoft\Windows\CurrentVersion\Explorer\MenuOrder\Start Menu\Programs\YahooPOPs!; Flags: uninsdeletekey dontcreatekey deletekey
Root: HKCU; Subkey: Software\Microsoft\Windows\CurrentVersion\Explorer\MenuOrder\Start Menu2\Programs\YahooPOPs!; Flags: uninsdeletekey dontcreatekey deletekey
Root: HKCU; Subkey: Software\Microsoft\Windows\CurrentVersion\Explorer\MenuOrder\Start Menu\Programs\YPOPs!; Flags: uninsdeletekey dontcreatekey
Root: HKCU; Subkey: Software\Microsoft\Windows\CurrentVersion\Explorer\MenuOrder\Start Menu2\Programs\YPOPs!; Flags: uninsdeletekey dontcreatekey
Root: HKCU; Subkey: Software\YPOPs!\YPOPs!\Settings; ValueType: dword; ValueName: IgnoreExactSize; ValueData: 1; Flags: dontcreatekey; Tasks: 
Root: HKCU; Subkey: Software\YPOPs!\YPOPs!\Settings; ValueType: dword; ValueName: nUserAgent; ValueData: 0; Flags: dontcreatekey uninsdeletevalue deletevalue; Tasks: 

[UninstallDelete]
Name: {app}\*.html; Type: files
Name: {app}\*.sendmail.txt; Type: files
Name: {app}\ypops.log; Type: files
Name: {app}; Type: dirifempty
Name: {userstartup}\YPOPs.lnk; Type: files

[InstallDelete]
Name: {pf}\YahooPOPs\mime*.dll; Type: files
Name: {pf}\YahooPOPs\libcurl*.dll; Type: files
Name: {pf}\YahooPOPs\*.html; Type: files
Name: {pf}\YahooPOPs\yahoopops.log; Type: files
Name: {pf}\YahooPOPs; Type: dirifempty
Name: {userstartup}\YahooPOPs.lnk; Type: files

[Code]
type
	IT = (IT_INSTALL, IT_UNINSTALL);

var
	InstallType: IT;

procedure DeleteSettings;
begin
	if MsgBox('Do you want the YPOPs! configuration settings to be deleted?',
				   mbConfirmation, MB_YESNO) = IDYES then
		if not RegDeleteKeyIncludingSubkeys(HKEY_CURRENT_USER, 'Software\YPOPs!') then
			MsgBox('WARNING: could not delete the YPOPs! configuration settings',
				   mbInformation, MB_OK);

end;

procedure CopyRegKeyValues(root: Integer; key1, key2: String);
var
  Names: TArrayOfString;
  I: Integer;
  S: String;
  vstr: String;
  vdw: Cardinal;
begin
  if RegGetValueNames(root, key1, Names) then begin
    S := '';
    for I := 0 to GetArrayLength(Names)-1 do
		if RegQueryDWordValue(root, key1, Names[I], vdw) then begin
			if not RegWriteDWordValue(root, key2, Names[I], vdw) then
				RaiseException('Could not write dword value for '+Names[I]);
		end else if RegQueryStringValue(root, key1, Names[i], vstr) then begin
			if not RegWriteStringValue(root, key2, Names[I], vstr) then
				RaiseException('Could not write string value for '+Names[I]);
		end else
			RaiseException('Could not read value for '+Names[I]);
		//S := S + Names[I] + #13#10;
		//MsgBox('List of values:'#13#10#13#10 + S, mbInformation, MB_OK);
  end else begin
    RaiseException('Could not get value names to copy settings');
  end;
  MsgBox('The YahooPOPs! configuration settings have been migrated to YPOPs!',
		 mbInformation, MB_OK);
end;

function CheckAndUninstall(keyName: String): Boolean;
var
	dispname, uninst, cmd, args: String;
	errorCode, i: Integer;
begin
	result := true; // indicates that we need to keep checking
	if RegKeyExists(HKEY_LOCAL_MACHINE, 'SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\'+keyName) then
	begin
		if not RegQueryStringValue(HKEY_LOCAL_MACHINE, 'SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\'+keyName,
			 'DisplayName', dispname) then
		begin
			// could not read the value
			MsgBox('Could not get YahooPOPs! DisplayName uninstall information',
				   mbInformation, MB_OK);
		end;
		if not RegQueryStringValue(HKEY_LOCAL_MACHINE, 'SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\'+keyName,
			 'UninstallString', uninst) then
		begin
			// could not read the value
			MsgBox('Could not get '+dispname+' uninstall command string',
				   mbInformation, MB_OK);
		end;
		// Ask the user a Yes/No question
		if MsgBox(dispname+' is installed.'+#13+
				  'It must be uninstalled before installing this version.'+#13+
				  'Do you wish to invoke the uninstaller now?',
			mbConfirmation, MB_YESNO) = IDYES then
		begin
			// user clicked Yes
			i := Pos('"', Copy(uninst,2, Length(uninst)));
			cmd := Copy(uninst, 2, i);
			args := Copy(uninst, i+3, Length(uninst));
			if not Exec(cmd, args, '', SW_SHOW,
						ewWaitUntilTerminated, errorCode) then
				RaiseException('Could not run uninstaller');
			if errorCode <> 0 then
				RaiseException('Error running uninstaller: '+SysErrorMessage(errorCode));
			exit;
		end else
			RaiseException(dispname+' is installed - you must uninstall it first');
	end;
	// not installed - we can proceed
	result := false;
end;

procedure StopApp(app: String);
var
	i: Integer;
	mutex: String;
	msg: String;
begin
	mutex := app + '_instance_mutex';
	msg   := app + '_instance_message';
	if CheckForMutexes(mutex) then begin
		PostBroadcastMessage(RegisterWindowMessage(msg), 1, 0);
		for i := 1 to 5 do begin
			Sleep(500);
			if not CheckForMutexes(mutex) then
				Exit;
		end;
		RaiseException(app + ' is running - you must shut it down first');
		while CheckForMutexes(mutex) do begin
			if MsgBox(app + ' is running - please shut it down, then press OK or press Cancel to abort installation',
					   mbInformation, MB_OKCANCEL) = IDCANCEL then
				RaiseException(app + ' is running - user cancelled installation');
		end;
	end;
end;

function InitializeSetup(): Boolean;
begin
	InstallType := IT_INSTALL;
	Result := false;

	StopApp('YAHOOPOPS!');
	StopApp('YPOPS!');

	// migrate YahooPOPs! registry settings to YPOPs!
	if RegKeyExists(HKEY_CURRENT_USER, 'Software\YahooPOPs!\YahooPOPs!')
	   and not RegKeyExists(HKEY_CURRENT_USER, 'Software\YPOPs!\YPOPs!') then begin
		// copy settings from YahooPOPs! to YPOPs!
		CopyRegKeyValues(HKEY_CURRENT_USER,
				'Software\YahooPOPs!\YahooPOPs!\Settings',
				'Software\YPOPs!\YPOPs!\Settings');
	end;


	while CheckAndUninstall('YahooPOPs!') do begin end; 	// check for <= 0.6 ypops
	while CheckAndUninstall('YahooPOPs_is1') do begin end; 	// check for 0.6.x ypops

	Result := true;
end;

procedure StartOnBootUp;
begin
	if MsgBox('Do you wish to automatically start YPOPs! when Windows Starts?',
			  mbConfirmation, MB_YESNO) = IDYES then begin
		CreateShellLink(
			  ExpandConstant('{userstartup}\YPOPs.lnk'), 	// link name
			  'Launch YPOPs! at Windows startup',			// description
			  ExpandConstant('{app}\ypops.exe'),			// exe
			  ExpandConstant(''),							// parameters
			  ExpandConstant('{app}'),						// workingdir
			  ExpandConstant('{app}\ypops.exe'),			// icon name
			  0,											// icon index
			  SW_SHOWNORMAL); 								// showcmd
	end else begin
		DeleteFile(ExpandConstant('{userstartup}\YPOPs.lnk'));
	end;
end;

procedure CurStepChanged(CurStep: TSetupStep);
begin
	if CurStep = ssInstall then
		StartOnBootUp;
end;

procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
begin
	if CurUninstallStep = usUninstall then
		DeleteSettings;
end;

function InitializeUninstall(): Boolean;
begin
	InstallType := IT_UNINSTALL;
	Result := true;

	StopApp('YAHOOPOPS!');
	StopApp('YPOPS!');
end;
